# Ouster Security Policy

## Overview

This security policy outlines the security support commitments for ouster-sdk users.

[Email](security@ouster.io) to learn more about Ouster's security SLAs and process.

## BSD-3-Clause License Users

- **Security SLA:** No security Service Level Agreement (SLA) is provided.
- **Release Schedule:** Releases are planned every 3 months. These releases
  will contain all security fixes implemented up to that point.
- **Version Support:** Security patches are only provided for the current
  release version.

## Reporting a Vulnerability

Please [email](security@ouster.io) to report a security vulnerability.

Please include the requested information listed below (as much as you can provide) to help us better understand 
the nature and scope of the possible issue:

- Type of issue (e.g. buffer overflow, SQL injection, cross-site scripting, etc.)
- Full paths of source file(s) related to the manifestation of the issue
- The location of the affected source code (tag/branch/commit or direct URL)
- Any special configuration required to reproduce the issue
- Step-by-step instructions to reproduce the issue
- Proof-of-concept or exploit code (if possible)
Impact of the issue, including how an attacker might exploit the issue
- This information will help us triage your report more quickly.

### Preferred Languages
We prefer all communications to be in English.

### Response time 
You should receive a response within 3 business days. 

If for some reason you do not, please follow up via email to ensure we received your original message.